'
' Functions and subroutines that handle notes
'
' A note contains the following information:
'
' 0 id
' 1 title
' 2 body
' 3 owner
' 4 parent note id
' 5 creation time
' 6 last modification time
' 7 acl id
' 8 number of children
' 9 children information
'
module Note

' convert a note to "binary" format
function ConvertToBin(Id, _
                      Title, _
                      Body, _
                      Owner, _
                      ParentId, _
                      NoteCreateTime, _
                      NoteModifyTime, _
                      AclId, _
                      NumberOfChildren, _
                      ChildrenArray)
  local Children

  Children = join(Sep2,ChildrenArray)
  ConvertToBin = join(Sep1,Id, _
                      Title, _
                      Body, _
                      Owner, _
                      ParentId, _
                      NoteCreateTime, _
                      NoteModifyTime, _
                      AclId, _
                      NumberOfChildren, _
                      Children)
end function

' convert a "binary" format note to its parts
sub    ConvertFromBin(BinaryFormatNote, _
                      Id, _
                      Title, _
                      Body, _
                      Owner, _
                      ParentId, _
                      NoteCreateTime, _
                      NoteModifyTime, _
                      AclId, _
                      NumberOfChildren, _
                      ChildrenArray)
  local Children
  split BinaryFormatNote by Sep1 to _
                      Id, _
                      Title, _
                      Body, _
                      Owner, _
                      ParentId, _
                      NoteCreateTime, _
                      NoteModifyTime, _
                      AclId, _
                      NumberOfChildren, _
                      Children
  splita Children by Sep2 to ChildrenArray
  if not IsDefined(NumberOfChildren) then NumberOfChildren = 0
'  NumberOfChildren = val(NumberOfChildren)
end sub

end module
