# This script is invoked by the tool make when compiling ScriptBasic
#
# make install
#
# This script copies the compiled files to the installation
# directories and sets the owner, group and permissions of the
# files.
#
CONFIGDIR=/etc/scriba
INCLUDE=/usr/share/scriba/include
SOURCE=/usr/share/scriba/source
MODULE=/usr/lib/scriba
LIB=/usr/lib
CACHE=/var/cache/scriba/cache
HEBTEMP=/var/cache/scriba/hebtemp
BIN=/usr/bin
LOG=/var/log/scriba

mkdir -p $LOG
chmod a+rw $LOG
mkdir -p $CONFIGDIR
chmod a+r $CONFIGDIR
mkdir -p $INCLUDE
chmod a+r $INCLUDE
mkdir -p $SOURCE
chmod a+r $SOURCE
mkdir -p $MODULE
chmod a+r $MODULE
mkdir -p $LIB
chmod a+r $LIB

#
# clean old cache files that may 
# have been created by previous version
#
if [ -e $CACHE ] ; then
 rm -rf $CACHE/*
fi
mkdir -p $CACHE
chmod a+rw $CACHE

if [ -e $HEBTEMP ] ; then
 rm -rf $HEBTEMP/*
fi
mkdir -p $HEBTEMP
chmod a+rw $HEBTEMP

cp ./scriba $BIN/scriba
chown root:root $BIN/scriba
chmod a+rx $BIN/scriba

cp ./cftc $BIN/cftc
chown root:root $BIN/cftc
chmod a+rx $BIN/cftc

/etc/init.d/sbhttpd stop
cp ./sbhttpd $BIN/sbhttpd
chown root:root $BIN/sbhttpd
chmod a+rx $BIN/sbhttpd
/etc/init.d/sbhttpd start

cp ./*.so $MODULE
chown root:root $MODULE/*
chmod a+r $MODULE/*
cp ./include/* $INCLUDE
chown root:root $INCLUDE/*
chmod a+r $INCLUDE/*
cp ./basicc.a $LIB
chown root:root $LIB/basicc.a
chmod a+r $LIB/basicc.a
cp ./heber.bas $SOURCE
chown root:root $SOURCE/*
chmod a+r $SOURCE/*

#
# note that there is no reason to save the old CONFIGDIR file
# because this CONFIGDIR file is a compiled binary file and
# the 'real' information that the system manager should not
# loose is at a location where he/she decided to store
# usually under the name scriba.conf.unix.lsp
#
./cftc scriba.conf.unix.lsp $CONFIGDIR/basic.conf

